using System;
using System.ServiceModel;

namespace MyTimeService
{
	[ServiceContract()]
	public interface ITimeService
	{
		[OperationContract]
		string MyOperation1(string myValue);

		[OperationContract]
		DateTime GetCurrentTime();
	}

	public class TimeService : ITimeService
	{
		public string MyOperation1(string myValue)
		{
			return "Hello: " + myValue;
		}

		public DateTime GetCurrentTime()
		{
			return DateTime.Now;
		}
	}

	internal class MyServiceHost
	{
		internal static ServiceHost myServiceHost = null;

		internal static void StartService()
		{
			// Consider putting the baseAddress in the configuration system
			// and getting it here with AppSettings
			Uri baseAddress = new Uri("http://localhost:8080/MyTimeService/TimeService");

			// Instantiate new ServiceHost 
			myServiceHost = new ServiceHost(typeof(TimeService), baseAddress);

			myServiceHost.Open();
		}

		internal static void StopService()
		{
			// Call StopService from your shutdown logic (i.e. dispose method)
			if (myServiceHost.State != CommunicationState.Closed)
				myServiceHost.Close();
		}
	}
}

